/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef NFAISTRING_H_
#define NFAISTRING_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "nfa.h"
#include "nfastate.h"
#include <string>
#include <vector>

class NfaIString : public Nfa
{
public:
	NfaIString(const std::string& str);
	virtual int length() const { return m_length; }
	virtual const NfaState* statesBegin() const { return &m_states[0]; }
	virtual const NfaState* statesEnd() const { return &m_states[m_states.size()]; }
	virtual int getStartPos() const { return 0; }
	virtual int getFinishPos() const { return m_states.size()-1; }
private:
	int m_length;
	std::vector<NfaState> m_states;
};

#endif

