/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ABSTRACTDECOMPRESSOR_H_
#define ABSTRACTDECOMPRESSOR_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "types.h"
#include <sigc++/sigc++.h>

class AbstractDecompressor
{
public:
	virtual ~AbstractDecompressor() {}
	virtual void reset() = 0;
	virtual void consumeDataChunk(const uint8_t* begin, const uint8_t* end) = 0;
	virtual void consumeEOF() = 0;
	virtual bool isError() = 0;
	virtual SigC::Signal2<void, const uint8_t*, const uint8_t*>& onDataOutput() = 0;
	virtual SigC::Signal0<void>& onError() = 0;
};

#endif

