/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef COMPRESSORRESPONSEFILTER_H_
#define COMPRESSORRESPONSEFILTER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "abstractresponsefilter.h"
#include "abstractcompressor.h"
#include "httpresponsemetadata.h"
#include "acceptencoding.h"
#include <sigc++/sigc++.h>

class CompressorResponseFilter : public AbstractResponseFilter, public SigC::Object
{
public:
	static AbstractResponseFilter* create(NextFilterProvider* follower,
		HttpResponseMetadata* metadata, const AcceptEncoding& aenc);
private:
	CompressorResponseFilter(AbstractResponseFilter* follower, AbstractCompressor* delegate);
	
	CompressorResponseFilter(const CompressorResponseFilter&);            //
	
	CompressorResponseFilter& operator=(const CompressorResponseFilter&); // not implemented
public:
	virtual ~CompressorResponseFilter();
	
	virtual void consumeDataChunk(const uint8_t* begin, const uint8_t* end);
	
	virtual void consumeEOF();
private:
	void processOutputData(const uint8_t* begin, const uint8_t* end);
private:
	AbstractResponseFilter* const m_pFollower;
	AbstractCompressor* const m_pDelegate;
};

#endif

