/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef REGEXP_H_
#define REGEXP_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include "intrusiveptr.h"

class RegExp : public IntrusiveRefCounter
{
public:
	RegExp();
	
	RegExp(const std::string& pattern, int flags);
	
	RegExp(const RegExp& other);
	
	virtual ~RegExp();
	
	RegExp& operator=(const RegExp& rhs);
	
	bool isNull() const { return !m_pImpl; }
	
	bool matches(const std::string& str) const;
	
	std::string serialize() const;
	
	bool unserialize(const std::string& data);
	
	void swap(RegExp& other);
private:
	struct Impl;
	Impl* m_pImpl;
	std::string m_pattern;
	int m_flags;
};

#endif

