/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef IMAGEFACTORY_H_
#define IMAGEFACTORY_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <map>
#include <string>
#include <gdkmm/pixbuf.h>

class ImageFactory
{
private:
	ImageFactory() {}
public:
	static ImageFactory& getInstance();
	static void add(const char* fname, const guint8* data, int data_length);
	Glib::RefPtr<Gdk::Pixbuf> get(const char* fname);
private:
	Glib::RefPtr<Gdk::Pixbuf> getDefaultPixbuf();
	typedef std::map<std::string, std::pair<const guint8*, int> > StorageType;
	StorageType m_storage;
};

#endif
