/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef LOGDIALOG_H_
#define LOGDIALOG_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "log.h"
#include <gtkmm/window.h>
#include <gtkmm/textbuffer.h>
#include <gtkmm/textview.h>
#include <gtkmm/adjustment.h>

class LogDialog : public Gtk::Window, protected Log::Listener
{
	friend class Application;
protected:
	virtual void append(const Log::Entry& entry);
	virtual void clear();
	void onVAdjustmentChanged(Gtk::Adjustment* a);
	void onVAdjustmentValueChanged(Gtk::Adjustment* a);
private:
	LogDialog();
	virtual ~LogDialog();
	LogDialog(const LogDialog&);              //
	LogDialog& operator=(const LogDialog&);   // not implemented
	void onClear();
	
	bool m_scrollAtBottom;
	Glib::RefPtr<Gtk::TextBuffer> m_pTextBuffer;
	Glib::RefPtr<Gtk::TextBuffer::Tag> m_pWarningTag;
	Glib::RefPtr<Gtk::TextBuffer::Tag> m_pErrorTag;
	Gtk::TextView* m_pTextView;
};

#endif

