/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef LOGDIALOG_H_
#define LOGDIALOG_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <wx/wx.h>
#include <wx/dialog.h>
#include <wx/listctrl.h>
#include "log.h"

class LogDialog : public wxDialog, protected Log::Listener
{
public:
	static void show();
protected:
	virtual void append(const Log::Entry& entry);
	virtual void clear();
private:
	LogDialog(wxWindow *parent);
	virtual ~LogDialog();
	LogDialog(const LogDialog&);              //
	LogDialog& operator=(const LogDialog&);   // not implemented
	void onClearLog(wxCommandEvent& evt);
	
	static LogDialog* m_spInstance;
	wxListCtrl *m_pListCtrl;
	
	DECLARE_EVENT_TABLE()
};

#endif
