/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef MASTERSTATE_H_
#define MASTERSTATE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <windows.h>
#include <winsock2.h>
#include <conf.h>
#include <rules.h>

class MasterState
{
private:
	struct SharedMemory
	{
		int m_configMod;
		int m_rulesMod;
		HANDLE m_hConfigShm;
		HANDLE m_hRulesShm;
		bool m_filteringEnabled;
		bool m_scriptFilteringEnabled;
		bool m_masterDead;
	};
public:
	MasterState();
	~MasterState();
	const Config& getConfig() const { return m_config; }
	void setConfig(const Config& config);
	const Rules& getRules() const { return m_rules; }
	void setRules(const Rules& rules);
	bool isFilteringEnabled() const { return m_pShm->m_filteringEnabled; }
	void setFilteringEnabled(bool val) { m_pShm->m_filteringEnabled = val; }
	bool isScriptFilteringEnabled() const { return m_pShm->m_scriptFilteringEnabled; }
	void setScriptFilteringEnabled(bool val) { m_pShm->m_scriptFilteringEnabled = val; }
	bool isMasterDead() const { return m_pShm->m_masterDead; }
	HANDLE getShmHandle() const { return m_hShm; }
	HANDLE getShmMutex() const { return m_hShmMutex; }
private:
	Config m_config;
	Rules m_rules;
	HANDLE m_hShmMutex;
	HANDLE m_hShm;
	SharedMemory *m_pShm;
};

#endif
