/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "trayicon.h"
#include "application.h"
#include <windows.h>

BEGIN_EVENT_TABLE(TrayIcon, wxTaskBarIcon)
	EVT_TASKBAR_LEFT_UP(TrayIcon::onMouseUp)
	EVT_TASKBAR_RIGHT_UP(TrayIcon::onMouseUp)
END_EVENT_TABLE()

TrayIcon::TrayIcon()
:	m_normalIcon(isTray16() ? "TrayIcon16" : "TrayIcon", wxBITMAP_TYPE_ICO_RESOURCE),
	m_unopIcon(isTray16() ? "TrayIconUnop16" : "TrayIconUnop", wxBITMAP_TYPE_ICO_RESOURCE)
{
	setNormalIcon();
}

void
TrayIcon::setNormalIcon()
{
	SetIcon(m_normalIcon, "BFilter");
}

void
TrayIcon::setUnopIcon()
{
	SetIcon(m_unopIcon, "BFilter [unoperational]");
}

bool
TrayIcon::isTray16()
{
	class WindowsVersion
	{
	public:
		WindowsVersion() {
			m_verInfo.dwOSVersionInfoSize = sizeof(m_verInfo);
			GetVersionEx(&m_verInfo);
		}
		
		bool lessThanXP() {
			if (m_verInfo.dwMajorVersion == 5) {
				return (m_verInfo.dwMinorVersion == 0);
			} else {
				return (m_verInfo.dwMajorVersion < 5);
			}
		}
	private:
		OSVERSIONINFO m_verInfo;
	};
	static WindowsVersion win_ver;
	
	return win_ver.lessThanXP(); 
}

void
TrayIcon::onMouseUp(wxTaskBarIconEvent& evt)
{
	wxGetApp().showTrayMenu();
}

