/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "traymenu.h"
#include "application.h"

BEGIN_EVENT_TABLE(TrayMenu, wxMenu)
	EVT_MENU(IDM_FILTER, TrayMenu::onFilter)
	EVT_MENU(IDM_FILTER_SCRIPTS, TrayMenu::onFilterScripts)
	EVT_MENU(IDM_CONFIG_BASIC, TrayMenu::onConfigBasic)
	EVT_MENU(IDM_CONFIG_ADVANCED, TrayMenu::onConfigAdvanced)
	EVT_MENU(IDM_LOG, TrayMenu::onLog)
	EVT_MENU(IDM_QUIT, TrayMenu::onQuit)
END_EVENT_TABLE()

TrayMenu::TrayMenu()
:	wxMenu("BFilter " VERSION)
{
	wxMenu* config_submenu = new wxMenu;
	config_submenu->Append(IDM_CONFIG_BASIC, "Basic");
	config_submenu->Append(IDM_CONFIG_ADVANCED, "Advanced");
	AppendCheckItem(IDM_FILTER, "Filter");
	Check(IDM_FILTER, true);
	AppendCheckItem(IDM_FILTER_SCRIPTS, "Filter Scripts");
	Check(IDM_FILTER_SCRIPTS, true);
	AppendSeparator();
	Append(IDM_CONFIG, "Configuration", config_submenu);
	Append(IDM_LOG, "Log");
	AppendSeparator();
	Append(IDM_QUIT, "Quit");
}

void
TrayMenu::onFilter(wxCommandEvent& evt)
{
	Enable(IDM_FILTER_SCRIPTS, !evt.IsChecked());
	Check(IDM_FILTER, !evt.IsChecked());
	wxGetApp().setFiltering(!evt.IsChecked());
}

void
TrayMenu::onFilterScripts(wxCommandEvent& evt)
{
	Check(IDM_FILTER_SCRIPTS, !evt.IsChecked());
	wxGetApp().setScriptFiltering(!evt.IsChecked());
}

void
TrayMenu::onConfigBasic(wxCommandEvent& evt)
{
	wxGetApp().showBasicConfigDialog();
}

void
TrayMenu::onConfigAdvanced(wxCommandEvent& evt)
{
	wxGetApp().showAdvancedConfigWindow();
}

void
TrayMenu::onLog(wxCommandEvent& evt)
{
	wxGetApp().showLogDialog();
}

void
TrayMenu::onQuit(wxCommandEvent& evt)
{
	wxGetApp().quit();
}

