/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ABSTRACTRESPONSEFILTER_H_
#define ABSTRACTRESPONSEFILTER_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>

class HtmlEscaper
{
public:
	static std::string escape(const std::string& str);
	static std::string unescape(const std::string& str);
private:
	typedef char EntityRecord[8];
private:
	struct EntityRecordComparator
	{
		static int compare(const char* lhs, const char* rhs) {
			return std::memcmp(lhs+1, rhs+1, sizeof(EntityRecord)-1);
		}
		bool operator()(const char* lhs, const char* rhs) {
			return compare(lhs, rhs) < 0;
		}
	};
	friend class EntityRecordComparator;
private:
	static const EntityRecord m_entityTable[];
};

#endif

