/*
    BFilter - a web proxy which removes banner ads
    Copyright (C) 2002  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTMLLEXER_H_
#define HTMLLEXER_H_

#include "htmllexercore.h"

class HtmlLexer : public HtmlLexerCore
{
	friend class HtmlLexerCore::Actions;
public:
	HtmlLexer() : HtmlLexerCore(this), m_cdataCommentLevel(0) {}
protected:
	virtual ~HtmlLexer() {}
private:
	virtual void processDocType(const ConstIterator& begin, const ConstIterator& end) = 0;

	virtual void processText(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual void processOpeningTagName(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual void processOpeningTag(const ConstIterator& begin, const ConstIterator& end, bool explicit_empty) = 0;
	
	virtual void processClosingTagName(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual void processClosingTag(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual bool processAttrName(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual void processAttrValue(const ConstIterator& begin, const ConstIterator& end) = 0;
	
	virtual bool isCDATAStarting() = 0;
	
	virtual bool isCDATAEnding(const ConstIterator& begin, const ConstIterator& end) = 0;
private:
	int m_cdataCommentLevel;
};

#endif

