/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTMLNODEWITHATTRIBUTES_H_
#define HTMLNODEWITHATTRIBUTES_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "htmlnode.h"
#include <string>
#include <map>

class HtmlNodeWithAttributes : virtual public HtmlNode
{
protected:
	HtmlNodeWithAttributes(const std::string& name, bool closed);
	
	HtmlNodeWithAttributes(const HtmlNodeWithAttributes& other);
public:
	virtual const std::string& getTagName() const;
	
	virtual void setTagName(const std::string& name);
	
	virtual int getTagType() const;
	
	virtual void setTagType(int type);
	
	virtual bool isClosed() const;
	
	virtual void setClosed(bool closed);
	
	virtual bool hasAdMark() const;
	
	virtual void setAdMark(bool mark);
	
	virtual const AttributeMap& getRawAttributes() const;
	
	virtual bool hasAttribute(const std::string& name) const;
	
	virtual std::string getRawAttribute(const std::string& name) const;
	
	virtual std::string getAttribute(const std::string& name) const;
	
	virtual void setRawAttribute(const std::string& name, const std::string& value);
	
	virtual void setAttribute(const std::string& name, const std::string& value);
	
	virtual void removeAttribute(const std::string& name);
private:
	std::string m_name;
	AttributeMap m_attributes;
	int m_type;
	bool m_isClosed;
	bool m_adMark;
};

#endif

