/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "htmlnodewithcontent.h"
#include "types.h"

HtmlNodeWithContent::HtmlNodeWithContent(const HtmlNodeWithContent& other)
:	m_buffer(other.m_buffer)
{
}

const Buffer&
HtmlNodeWithContent::getContent() const
{
	return m_buffer;
}
	
void
HtmlNodeWithContent::setContent(const Buffer& content)
{
	m_buffer = content;
}

void
HtmlNodeWithContent::appendContent(const Buffer::ConstIterator& begin, const Buffer::ConstIterator& end)
{
	m_buffer.appendData(begin, end);
}

void
HtmlNodeWithContent::appendContent(const uint8_t* begin, const uint8_t* end)
{
	m_buffer.appendData(begin, end);
}

void
HtmlNodeWithContent::appendContent(const std::string& text)
{
	m_buffer.appendData(reinterpret_cast<const uint8_t*>(text.data()),
		reinterpret_cast<const uint8_t*>(text.data())+text.length());
}

