/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTMLNODEWITHCONTENT_H_
#define HTMLNODEWITHCONTENT_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "htmlnode.h"
#include "buffer.h"
#include <string>

class HtmlNodeWithContent : virtual public HtmlNode
{

protected:
	HtmlNodeWithContent() {}
	
	HtmlNodeWithContent(const HtmlNodeWithContent& other);
public:
	virtual const Buffer& getContent() const;
	
	virtual void setContent(const Buffer& content);
	
	virtual void appendContent(const Buffer::ConstIterator& begin, const Buffer::ConstIterator& end);
	
	virtual void appendContent(const uint8_t* begin, const uint8_t* end);
	
	virtual void appendContent(const std::string& text);
private:
	Buffer m_buffer;
};

#endif

