/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "htmlnodewithoutattributes.h"

const std::string&
HtmlNodeWithoutAttributes::getTagName() const
{
	static const std::string empty_string;
	return empty_string;
}

void
HtmlNodeWithoutAttributes::setTagName(const std::string& name)
{
}

int
HtmlNodeWithoutAttributes::getTagType() const
{
	return 0;
}

void
HtmlNodeWithoutAttributes::setTagType(int type)
{
}

bool
HtmlNodeWithoutAttributes::isClosed() const
{
	return false;
}

void
HtmlNodeWithoutAttributes::setClosed(bool closed)
{
}

bool
HtmlNodeWithoutAttributes::hasAdMark() const
{
	return false;
}

void
HtmlNodeWithoutAttributes::setAdMark(bool mark)
{
}

const HtmlNode::AttributeMap&
HtmlNodeWithoutAttributes::getRawAttributes() const
{
	static const AttributeMap empty_map;
	return empty_map;
}

bool
HtmlNodeWithoutAttributes::hasAttribute(const std::string& name) const
{
	return false;
}

std::string
HtmlNodeWithoutAttributes::getRawAttribute(const std::string& name) const
{
	return "";
}

std::string
HtmlNodeWithoutAttributes::getAttribute(const std::string& name) const
{
	return "";
}

void
HtmlNodeWithoutAttributes::setRawAttribute(const std::string& name, const std::string& value)
{
}

void
HtmlNodeWithoutAttributes::setAttribute(const std::string& name, const std::string& value)
{
}

void
HtmlNodeWithoutAttributes::removeAttribute(const std::string& name)
{
}

