/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTTPMESSAGEMETADATA_H_
#define HTTPMESSAGEMETADATA_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "httpstartline.h"
#include "httpheaderscollection.h"
#include <cstddef>

class HttpMessageMetadata
{
public:
	enum BodyStatus {
		BODY_SIZE_KNOWN,
		BODY_SIZE_UNKNOWN,
		NO_BODY_BUT_PRESERVE_HEADERS
	};
	
	virtual ~HttpMessageMetadata() {}
	
	virtual const HttpStartLine& getStartLine() const = 0;
	
	virtual HttpHeadersCollection& headers() = 0;
	
	virtual const HttpHeadersCollection& headers() const = 0;
	
	virtual BodyStatus getBodyStatus() const = 0;
	
	virtual void setBodyStatus(BodyStatus status) = 0;
	
	virtual std::size_t getBodySize() const = 0;
	
	virtual void setBodySize(std::size_t size) = 0;
};

#endif

