/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef HTTPSTARTLINE_H_
#define HTTPSTARTLINE_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "httpversion.h"
#include <string>
#include <iosfwd>

class HttpStartLine
{
public:
	virtual ~HttpStartLine() {}
	
	virtual const HttpVersion& getHttpVersion() const = 0;
	
	virtual void setHttpVersion(const HttpVersion& version) = 0;
	
	virtual std::string toString() const = 0;
	
	virtual void toStream(std::ostream& strm) const = 0;
};


inline std::ostream&
operator<<(std::ostream& strm, const HttpStartLine& start_line)
{
	start_line.toStream(strm);
	return strm;
}

#endif

