/*
    BFilter - a smart ad-filtering web proxy
    Copyright (C) 2002-2003  Joseph Artsimovich <joseph_a@mail.ru>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef JSENVPROXY_H_
#define JSENVPROXY_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "jsenvironment.h"

class JSEnvProxy
{
public:
	JSEnvProxy() : m_env(0), m_env_master(true) {}
	JSEnvProxy(JSEnvProxy& proxy) // share the environment
	{
		if (!proxy.m_env) {
			proxy.m_env = new JSEnvironment();
		}
		m_env = proxy.m_env;
		m_env_master = false;
	}
	~JSEnvProxy()
	{
		if (m_env && m_env_master)
			delete m_env;
	}
	JSEnvironment* operator->()
	{
		if (!m_env) {
			m_env = new JSEnvironment();
		}
		return m_env;
	}
	JSEnvironment& operator*()
	{
		if (!m_env) {
			m_env = new JSEnvironment();
		}
		return *m_env;
	}
	// side effect: reseting the slave proxy makes it independent
	void reset()
	{
		if (m_env) {
			if (m_env_master)
				delete m_env;
			m_env = 0;
			m_env_master = true;
		}
	}
private:
	JSEnvProxy& operator=(const JSEnvProxy&); // no way to copy the proxy
	
	JSEnvironment *m_env;
	bool m_env_master;
};

#endif
